import java.sql.*;
import java.util.Properties;
class SSLTest implements Runnable {
    private Properties p;
    private Connection c;	
    private String DB_NODE;
    private String DB;
    private String QUERY;
    private int threadid;
    private long start;
    private long end;
    SSLTest(int threadid) { 
	this.p = new Properties();
	this.p.setProperty("user","user");
	this.p.setProperty("password","password");
	this.p.setProperty("charSet","ISO-8859-2");
	/*
	    Here is how to initiate an SSL connection. Just set
	    'keystorepw' and 'keystore' properties and pass them
	    to the driver together with the other properties. If these
	    two properties are not set at all or they are set to "" then 
	    a normal socket will be created unless the back end requieres
	    an SSL connection.
	    
	    If you set the type of a record as 'hostssl' in pg_hab.conf
	    you _must_ connect to that database over SSL.
	    
	    If you set the type of a record as 'host' in pg_hba.conf
	    you can choose either an SSL or a normal socket to 
	    connect to that database.
	    
	    Your back-end must be compiled with --with-openssl if
	    you want to make it 'SSLable'.
	    
	    I see no point in using SSL connecting to a back-end on the
	    same computer.  
	*/
	// the pasword of the keystore
	this.p.setProperty("keystorepw","changeit");
	// where to find the keystore that sould be applied
	// it would be the same as or different from that of the JVM 
	this.p.setProperty("keystore","/tmp/keystore");
	// the name of the host the back-end is running on
	this.DB_NODE = "dbnode.yourdomain.com";
	// the name of the database you want to use
	this.DB = "yourdb";
	// The query to be executed. You can create an instance of this
	// class by passing a query as a parameter even a specific
	// query for all thread 
	this.QUERY = "select 'Hello'";
	this.threadid=threadid;
    }
    
    public void run(){
	try {
	    Class.forName("org.postgresql.Driver");
	    this.start = System.currentTimeMillis();
	    this.c = 
		DriverManager.getConnection("jdbc:postgresql://"+this.DB_NODE+"/"+this.DB,this.p);
	    Statement st = this.c.createStatement();
	    ResultSet rs = st.executeQuery(this.QUERY);
	    rs.close();
	    this.c.close();    
	    System.out.println("Thread("+this.threadid+
		") "+(System.currentTimeMillis()-this.start)+" [msec]");
	} catch (Exception e) {
	    System.out.println("Thread("+this.threadid+") - BUG: " + e.getMessage() );
	} 
	
    }    
}